// Intersectional Map

import java.util.ArrayList;

Integer[] EU_List = {15,20,27,28,33,35,36,40,49,52,73,78,79,96,107,108,110,115,123,124,126,138,145,152,155};

class Point
{
  public int id;
  public float x, y;
  public short count;
  public short mark;
  public ArrayList labels = new ArrayList();
  public ArrayList lcount = new ArrayList();

  public short[] gender = {0,0,0};
  public short[] migration = {0,0,0};
  public short[] income = {0,0,0,0,0};
  public short[] education = {0,0,0,0};
  public short[] age = {0,0,0,0};
  public float heter;
}

class Pair
{
  public Point a, b;
  public short count;
  public float length;
}

class Path
{
  public ArrayList points = new ArrayList();
  public ArrayList labels = new ArrayList();
  public ArrayList pairs = new ArrayList();
}

class Poll
{
  public short id;
  public byte gender;
  public byte age;
  public byte education;
  public int migration;
  public byte income;
  public Path[] path = new Path[2];
  public float currentPosition = 0;
  public int currentPath = 0;
  public int currentPoint = 0;
  public float x = 0;
  public float y = 0;
  public float speed = 0;
  Poll()
  {
    path[0] = new Path();
    path[1] = new Path();
  }
  public void randomize(float r)
  {
    x += r * random(-1,1)/10;
    y += r * random(-1,1)/10;
    if (x > r) x *=0.9;
    if (x < -r) x *=0.9;
    if (y > r) y *=0.9;
    if (y < -r) y *=0.9;
  }
}

class Label
{
  public short id;
  public String text;
  public int count;
}

// Point[] point = new Point[10000];
// Poll[]  poll  = new Poll[1000];
// Path[]  path  = new Path[100000];
// Label[] label = new Label[1000];

class Viewer
{
  
  PFont font;
  
  private int x, y, w, h;
  public float z = 1;
  private float offsetX, offsetY, Width, Height;
  private boolean dirty, moving = false, showmap = false, movement_enabled = false;

  private PGraphics buf;
  private PGraphics pathbuf;
  private PImage image;

  private int mode = 0; // stuff like View, Move-Point, Merge-Point, ....
  private Point selected = null;
  private Point temp = null;

  private ArrayList points;
  private ArrayList pairs;
  private ArrayList polls;
  private ArrayList labels;

  Viewer(int x, int y ,int w, int h)
  {
    this.x = x; this.y = y;
    this.w = w; this.h = h;
    image = loadImage("karte.png");
    buf = createGraphics(w, h, JAVA2D);
    pathbuf = createGraphics(image.width, image.height, JAVA2D);
    offsetX = image.width/2 - w/2;
    offsetY = image.height/2 - h/2;
    clip();


    points = new ArrayList();
    pairs  = new ArrayList();
    polls  = new ArrayList();
    labels  = new ArrayList();
    readLabels();
    readPoints();
    readPolls();
    readPath();
    calcPointColor();
    drawPathBuf();
  }

  public void draw()
  {
    int n;
    //ORTSPUNKTE TEXT LABEL
    buf.textFont(font1);
    buf.beginDraw();
    // Hintergrund löschen (weiss)
    buf.background(255,255,255);
    // KARTE ZEICHNEN
    if (showmap == true)
    {
      buf.image(image.get(round(offsetX), round(offsetY), round(Width), round(Height)), 0, 0 , w, h);
    }
    
    else
    {
      // gebufferte Wege zeichnen
      buf.image(pathbuf.get(round(offsetX), round(offsetY), round(Width), round(Height)), 0, 0 , w, h);
    }

    // Wege: n auf Null setzen um auszuschalten
    n= pairs.size();
    n=0;
    // WEGFARBE definieren
    buf.noFill();
    buf.stroke(164,150,96,40);
    buf.strokeWeight(1/z);
    buf.strokeCap(ROUND);
    buf.strokeJoin(ROUND);
    
    for(int i = 0; i < n ; i++)
    {
      Pair P = (Pair)pairs.get(i);
      int x1 = round((P.a.x - offsetX) / z);
      int y1 = round((P.a.y - offsetY) / z);
      int x2 = round((P.b.x - offsetX) / z);
      int y2 = round((P.b.y - offsetY) / z);
      if ( ( ( x1 < w ) && ( x1 > 0 ) && ( y1 < h ) && ( y1 > 0 ) ) || ( ( x2 < w ) && ( x2 > 0 ) && ( y2 < h ) && ( y2 > 0 ) ) )
      {
        // Liniendicke
        if (P.count > 0)
        {
          buf.smooth();
          buf.strokeWeight(0.1 * sqrt(P.count)/z);
          buf.beginShape();
          buf.vertex(x1,y1);
          buf.vertex(x2,y2);
          buf.endShape();
        }
      }
    }


    n = points.size();
    buf.noStroke();
  
    for(int i = 0; i < n ; i++)
    {
      Point P = (Point)points.get(i);
      int x = round((P.x - offsetX) / z);
      int y = round((P.y - offsetY) / z);
      if ( ( x < w ) && ( x > 0 ) && ( y < h ) && ( y > 0 ) )
      {
        // Punktgrösse
        float r;
        if (P.count > 0)
        {
          // Punkte mit Bezeichnung
          r = 1.5 * sqrt(P.count + 4)/z;
          //r = 4 * sqrt(P.count + 0.2)/z;  //FORMEL verändert
        }
        else
        {
          // Punkte ohne Bezeichnung
          // r=1/z;
          r = 0;
        }
        if (P.mark == 0)
        {
          buf.fill(0,0,255);
        } else if (P.mark == 1)
        {
          buf.fill(128,128,128);
        } else if (P.mark == 2)
        {
          buf.fill(225,150,0);
        } else if (P.mark == 3)
        {
          buf.fill(0,225,0);
        } else if (P.mark == 4)
        {
          buf.fill(0,0,0);
        }

        if (P == selected)
        {
            
                buf.fill(255,0,0);  //Markierungsfarbe
                buf.ellipse(x, y , r*3, r*3);
                buf.fill(255,255,255);  //Markierungsfarbe
                buf.ellipse(x, y , r*1.1, r*1.1);
        }
        else if (P == temp)
        {
          buf.fill(255,255,255); //kein Geschlecht Punkte
        }
        
        // ORTSPUNKTE - Farbe
        buf.smooth();
      //  buf.fill(204,0,102, P.heter * 10);
  buf.fill(204,0,102, P.heter * 4.2);
        //buf.fill(177,0,93, P.heter * 2.5);
        buf.strokeWeight(1);
        buf.stroke(177,0,93,10);


     
        buf.ellipse(x, y , r, r);

        if (( z < 0.3 ) && (r > 0))
        {
          int m = P.labels.size();
          for(int j = 0 ; j < m ; ++j)
          {
            Label L = (Label)P.labels.get(j);
            if (L.id > 0)
            //ORTSPUNKTE - Textlabel     
            {
               buf.fill(82,59,61);
              buf.text(L.text, x+r*0.5, y-r*0.5+j*12);
            }
          }
        }
      }
    }

    n = polls.size();
    // buf.stroke(0);
    buf.strokeWeight(1);
    buf.rectMode(CENTER);
    float r = 5/z;
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll)polls.get(i);
      if (poll.path[poll.currentPath].pairs.size() > 1)
      {
        float scale = 1.0;
        Pair pair = (Pair)poll.path[poll.currentPath].pairs.get(poll.currentPoint);
        Label label = (Label)poll.path[poll.currentPath].labels.get(poll.currentPoint);
        float l = pair.length;
        if (poll.currentPosition > l)
        {
          poll.currentPoint += 1;
          if (poll.currentPoint >= poll.path[poll.currentPath].pairs.size())
          {
            poll.currentPoint = 0;
            poll.currentPath = 1 - poll.currentPath;
          }
          if (poll.currentPoint >= poll.path[poll.currentPath].pairs.size())
          {
            poll.currentPoint = 0;
            poll.currentPath = 1 - poll.currentPath;
          }
          pair = (Pair)poll.path[poll.currentPath].pairs.get(poll.currentPoint);
          label = (Label)poll.path[poll.currentPath].labels.get(poll.currentPoint);

          poll.currentPosition -= l;
          if (label.id > 0)
          {
            poll.currentPosition /= 10;
          }
          l = pair.length;
        }
        Point A = (Point)poll.path[poll.currentPath].points.get(poll.currentPoint);
        Point B = (Point)poll.path[poll.currentPath].points.get(poll.currentPoint + 1);
        int x = round(( (A.x + poll.x + poll.currentPosition * (B.x - A.x)/l) - offsetX) / z);
        int y = round(( (A.y + poll.y + poll.currentPosition * (B.y - A.y)/l) - offsetY) / z);

        if ((label.id > 0) && ( poll.currentPosition < 2.0 ))
        {
          scale = 1.0 + 1.0 * poll.currentPosition * ( 2.0 - poll.currentPosition );
          poll.currentPosition += ( 0.1 * poll.speed );
        }
        else
        {
          scale = 1.0;
          poll.currentPosition += poll.speed;
        }
        if ( ( x < w ) && ( x > 0 ) && ( y < h ) && ( y > 0 ) && ( poll.speed > 0 ) )
        {
                  if ((selected != null) && (A.id == selected.id) && (poll.speed == 5.0))          
          {
            poll.currentPosition = 0.0;
            scale = 1.5;
            poll.randomize(10);
          }
          else
          {
            // poll.speed=1;
            // poll.randomize(1);
          }

          // Farbe anhand des Geschlechtes
           if (poll.gender == 2)
          {
         buf.stroke(180,216,0,255);
            buf.fill(180,216,0,120);
          }
          else if (poll.gender == 1)
          {
            buf.stroke(0,178,235,255); 
            buf.fill(0,178,235,120);
          
          }
          else
          {
            buf.stroke(255,255,255);
            buf.fill(255,255,255);
          }

          // Form nach Migration
          if (poll.migration == 0)
          {
            buf.rect(x,y,r*scale,r*scale);
          }
          else if (poll.migration == 1)
          {
            buf.triangle(x-r*scale*0.55, y+r*scale*0.55, x+r*scale*0.55, y+r*scale*0.55, x, y-r*scale*0.6);
          }
          else
          {
            buf.quad(x, y+r*scale*0.7, x+r*scale*0.35, y, x, y-r*scale*0.7, x-r*scale*0.35,y);
          }
        }
      }
    }
    
    if (true)
    {
      //Bezirke 
      buf.fill (108,194,175,150);   
      buf.textFont(font5);
      int xb0 = round( (1830 - offsetX) / z);
      int yb0 = round( (1927 - offsetY) / z);
      buf.text("INNERE STADT", xb0, yb0);
      int xb1 = round( (1200 - offsetX) / z);
      int yb1 = round( (522 - offsetY) / z);
      buf.text("ANDRITZ", xb1, yb1);
      int xb2 = round( (1650 - offsetX) / z);
      int yb2 = round( (1370 - offsetY) / z);
      buf.text("GEIDORF", xb2, yb2);
      int xb3 = round( (2197 - offsetX) / z);
      int yb3 = round( (2087 - offsetY) / z);
      buf.text("ST. LEONHARD", xb3, yb3);
      int xb5 = round( (1056 - offsetX) / z);
      int yb5 = round( (1897 - offsetY) / z);
      buf.text("LEND", xb5, yb5);
      int xb6 = round( (1210 - offsetX) / z);
      int yb6 = round( (2637 - offsetY) / z);
      buf.text("GRIES", xb6, yb6);
      int xb7 = round( (2040 - offsetX) / z);
      int yb7 = round( (2867 - offsetY) / z);
      buf.text("JAKOMINI", xb7, yb7);
      int xb8 = round( (2062 - offsetX) / z);
      int yb8 = round( (3625 - offsetY) / z);
      buf.text("LIEBENAU", xb8, yb8);
      int xb9 = round( (3036 - offsetX) / z);
      int yb9 = round( (2987 - offsetY) / z);
      buf.text("ST.PETER", xb9, yb9);
      int xb10 = round( (3008 - offsetX) / z);
      int yb10 = round( (2242 - offsetY) / z);
      buf.text("WALTENDORF", xb10, yb10);
      int xb11 = round( (3256 - offsetX) / z);
      int yb11 = round( (1811 - offsetY) / z);
      buf.text("RIES", xb11, yb11);
      int xb12 = round( (2728 - offsetX) / z);
      int yb12 = round( (733 - offsetY) / z);
      buf.text("MARIATROST", xb12, yb12);
      int xb13 = round( (382 - offsetX) / z);
      int yb13 = round( (1247 - offsetY) / z);
      buf.text("GÖSTING", xb13, yb13);
      int xb14 = round( (262 - offsetX) / z);
      int yb14 = round( (2155 - offsetY) / z);
      buf.text("EGGENBERG", xb14, yb14);
      int xb15 = round( (473 - offsetX) / z);
      int yb15 = round( (3010 - offsetY) / z);
      buf.text("WETZELSDORF", xb15, yb15);
      int xb16 = round( (522 - offsetX) / z);
      int yb16 = round( (4057 - offsetY) / z);
      buf.text("STRASSGANG", xb16, yb16);
      int xb17 = round( (1576 - offsetX) / z);
      int yb17 = round( (4000 - offsetY) / z);
      buf.text("PUNTIGAM", xb17, yb17);
      }
      
          

    buf.endDraw();
    image(buf.get(0,0,w,h),x,y,w,h);
  }

private void drawPathBuf()
  {
    int n;
    pathbuf.beginDraw();
    pathbuf.background(255,255,255);
    pathbuf.noFill();
    pathbuf.stroke(164,150,96,40);
    pathbuf.strokeWeight(1/z);
    pathbuf.strokeCap(ROUND);
    pathbuf.strokeJoin(ROUND);
    pathbuf.smooth();
    n= pairs.size();
    for(int i = 0; i < n ; i++)
    {
      Pair P = (Pair)pairs.get(i);
      pathbuf.strokeWeight(0.1 * sqrt(P.count));
      pathbuf.beginShape();
      pathbuf.vertex(P.a.x,P.a.y);
      pathbuf.vertex(P.b.x,P.b.y);
      pathbuf.endShape();
    }
    pathbuf.endDraw();
  }


public void drawPointInfo(int x, int y, int lang)
  {
    if (selected == null) return;
    fill(200,200,200,200);
    rect(0,0, 250, 500);


    
//---------------------------------------------------------------
// Pie chart: Geschlecht
//---------------------------------------------------------------
strokeWeight(1);
stroke(180,216,0,255);
fill(180,216,0,120);
arc (x+50, y+110,60, 60, - HALF_PI,TWO_PI * selected.gender[2] / selected.count - HALF_PI); //weiblich

stroke(0,178,235,255); 
fill(0,178,235,120);
arc (x+50, y+110, 60, 60, - TWO_PI * selected.gender[1] / selected.count - HALF_PI, - HALF_PI ); //männlich

//Beschriftungen Tortendiagramm / Balkendiagramm
fill(177,0,93);
textFont(font3);
text ("GESCHLECHT:", x+10, y+70);
text ("ALTER:", x+10, y+160);
text ("MIGRATION:", x+10, y+250);
text("BILDUNG:", x+10,y+325);
text("EINKOMMEN:", x+10,y+400);

//Ortsname
          fill(255,0,0);
          int m = selected.labels.size();
          for(int j = 0 ; j < m ; ++j)
          {
            Label L = (Label)selected.labels.get(j);
            if (L.id > 0)
                     {
              text(L.text, x+10,y+10);
            }
          }

fill(0,0,0,190);
textFont(font0);
//text ("Heterogenität:  " + selected.heter, x+10, y+30);
text ("Heterogenität:  " + nf(selected.heter,2,1), x+10, y+30);
text ("Personenfrequenz:  " + selected.count, x+10, y+45);
text ("14-19", x+10, y+180);
text ("20-39", x+10, y+195);
text ("40-59", x+10, y+210);
text ("60 +", x+10, y+225);
text ("A", x+10, y+270);
text ("EU", x+10, y+285);
text ("N-EU", x+10, y+300);
text ("niedrig", x+10, y+345);
text ("mittel", x+10, y+360);
text ("hoch", x+10, y+375);
text ("s. niedr.", x+10, y+420);
text ("niedrig", x+10, y+435);
text ("mittel", x+10, y+450);
text ("hoch", x+10, y+465);

fill(180,180,0);
text("Frauen: ", x+110, y +120);
fill(0,178,235);
text("Männer: ", x+110, y +135);

fill(0,0,0,190);
rectMode (CORNER);
noFill();
strokeWeight(1);
stroke(0,0,0,180);

//Geschlecht
text (nf(100.0 * selected.gender[1] / selected.count,2,1) ,  x+ 150, y + 135);
text (nf(100.0 * selected.gender[2] / selected.count,2,1) ,  x+ 150, y + 120);

//ALTER
if  (selected.age[0] > 0) {
rect(x+50, y+170, 150.0*selected.age[0] / selected.count, 10);
text (nf(100.0 * selected.age[0] / selected.count,2,1) ,  x+ 55 + 150.0*selected.age[0] / selected.count, y + 180);
}
if  (selected.age[1] > 0) {
rect(x+50, y+185, 150.0*selected.age[1] / selected.count, 10);    
text (nf(100.0 * selected.age[1] / selected.count,2,1) ,  x+ 55 + 150.0*selected.age[1] / selected.count, y + 195);
}
if  (selected.age[2] > 0) {
rect(x+50, y+200, 150.0*selected.age[2] / selected.count, 10);    
text (nf(100.0 * selected.age[2] / selected.count,2,1) ,  x+ 55 + 150.0*selected.age[2] / selected.count, y + 210);
}
if  (selected.age[3] > 0) {
rect(x+50, y+215, 150.0*selected.age[3] / selected.count, 10);    
text (nf(100.0 * selected.age[3] / selected.count,2,1) ,  x+ 55 + 150.0*selected.age[3] / selected.count, y + 225);
}

//MIGRATION
if  (selected.migration[0] > 0) {
rect(x+50, y+260, 150.0*selected.migration[0] / selected.count, 10);
text (nf(100.0 * selected.migration[0] / selected.count,2,1) ,  x+ 55 + 150.0*selected.migration[0] / selected.count, y +270);
}
if  (selected.migration[1] > 0) {
rect(x+50, y+275, 150.0*selected.migration[1] / selected.count, 10);    
text (nf(100.0 * selected.migration[1] / selected.count,2,1) ,  x+ 55 + 150.0*selected.migration[1] / selected.count, y + 285);
}
if  (selected.migration[2] > 0) {
rect(x+50, y+290, 150.0*selected.migration[2] / selected.count, 10);    
text (nf(100.0 * selected.migration[2] / selected.count,2,1) ,  x+ 55 + 150.0*selected.migration[2] / selected.count, y + 300);
}

//BILDUNG
if  (selected.education[1] > 0) {
rect(x+50, y+335, 150.0*selected.education[1] / selected.count, 10);
text (nf(100.0 * selected.education[1] / selected.count,2,1) ,  x+ 55 + 150.0*selected.education[1] / selected.count, y +345);
}
if  (selected.education[2] > 0) {
rect(x+50, y+350, 150.0*selected.education[2] / selected.count, 10);    
text (nf(100.0 * selected.education[2] / selected.count,2,1) ,  x+ 55 +150.0*selected.education[2] / selected.count, y + 360);
}
if  (selected.education[3] > 0) {
rect(x+50, y+365, 150.0*selected.education[3] / selected.count, 10);    
text (nf(100.0 * selected.education[3] / selected.count,2,1) ,  x+ 55 + 150.0*selected.education[3] / selected.count, y + 375);
}

//EINKOMMEN
if  (selected.income[1] > 0) {
rect(x+50, y+410, 150.0*selected.income[1] / selected.count, 10);
text (nf(100.0 * selected.income[1] / selected.count,2,1) ,  x+ 55 + 150.0*selected.income[1] / selected.count, y + 420);
}
if  (selected.income[2] > 0) {
rect(x+50, y+425, 150.0*selected.income[2] / selected.count, 10);    
text (nf(100.0 * selected.income[2] / selected.count,2,1) ,  x+ 55 + 150.0*selected.income[2] / selected.count, y + 435);
}
if  (selected.income[3] > 0) {
rect(x+50, y+440, 150.0*selected.income[3] / selected.count, 10);    
text (nf(100.0 * selected.income[3] / selected.count,2,1) ,  x+ 55 +150.0*selected.income[3] / selected.count, y + 450);
}
if  (selected.income[4] > 0) {
rect(x+50, y+455, 150.0*selected.income[4] / selected.count, 10);    
text (nf(100.0 * selected.income[4] / selected.count,2,1) ,  x+ 55 + 150.0*selected.income[4] / selected.count, y + 465);
}

  } 
  

  public void toggleMap()
  {
    showmap = ! showmap;
  }
  public void mousePressed()
  {
    // findPoint(getX(), getY(), max(15.0 * z, 6.0) );
    Point P = findPoint(getX(), getY(), max(15.0 * z, 6.0) );
    if ( P == null)
    {
      selected = null;
    }
    else
    {
      selected = P;
      println("Found Point " + P.id + " (" + P.count + "x)");
      // splitPairs(P,getX(), getY(), max(10.0 * z, 4.0));
      int n = P.labels.size();
      for(int i = 0; i < n ; i++)
      {
        Label L = (Label)P.labels.get(i);
        Integer count = (Integer)P.lcount.get(i);
        println("   " + L.text + " (" + count + "x)");
      }
      // Statistik
      println("   gender:    " + P.gender[0] + " , " + P.gender[1] + " , " + P.gender[2] );
      println("   migration: " + P.migration[0] + " , " + P.migration[1] + " , " + P.migration[2] );
      println("   age:       " + P.age[0] + " , " + P.age[1] + " , " + P.age[2] + " , " + P.age[3]);
      println("   income:    " + P.income[0] + " , " + P.income[1] + " , " + P.income[2] + " , " + P.income[3] + " , " + P.income[4]);
      println("   education: " + P.education[0] + " , " + P.education[1] + " , " + P.education[2] + " , " + P.education[3]);
      println("   -> color:  " + P.heter);

      // Find Polls with that point
      n = polls.size();
      for(int i = 0; i < n ; i++)
      {
        Poll poll = (Poll)polls.get(i);
        for(int j=0; j < 2 ; ++j)
        {
          int m = poll.path[j].points.size();
          for(int k=0; k < m ; ++k)
          {
            Point point = (Point)poll.path[j].points.get(k);
            Label label = (Label)poll.path[j].labels.get(k);
            if ((point == selected) && (label.id > 0) && (poll.speed > 0.1))
            {
              poll.speed = 5.0;
            }
          }
        }
        
      }

    }
    // int i = findPair(getX(), getY(), max(15.0 * z, 6.0) );
  }

  public Point findPoint(float x, float y, float r)
  {
    Point point = null;
    float rr = r*r;
    int n = points.size();
    for(int i = 0; i < n ; i++)
    {
      Point P = (Point)points.get(i);
      float rtmp = ((P.x - x)*(P.x - x) + (P.y -y)*(P.y -y));
      if (( rtmp < rr ) && (P.labels.size() > 1))
      {
        point = P;
        rr = rtmp;
      }
    }
    return point;
  }
  
  public void splitPairs(Point S, float x, float y, float r)
  {
    int n = pairs.size();
    for(int i = 0; i < n ; i++) {
      Pair P = (Pair)pairs.get(i);
      float ll = ( (P.a.x-P.b.x)*(P.a.x-P.b.x)+(P.a.y-P.b.y)*(P.a.y-P.b.y) );
      float m = ( (P.a.x-P.b.x)*(P.a.x-x)+(P.a.y-P.b.y)*(P.a.y-y) ) / ll;
      float dist = ( (P.a.x - P.b.x) * (P.a.y - y)-(P.a.y - P.b.y) * (P.a.x - x) ) / ( sqrt(ll));
      dist = abs(dist);

      if ((dist < r ) && (m < 1) && (m > 0) )
      {
        if ((P.a != S ) && (P.b != S))
        {
          splitPair(P,S);
        }
      }
    }
  }

  public int findPair(float x, float y, float r)
  {
    int index= -1;
    int n = pairs.size();
    for(int i = 0; i < n ; i++) {
      Pair P = (Pair)pairs.get(i);
      float ll = ( (P.a.x-P.b.x)*(P.a.x-P.b.x)+(P.a.y-P.b.y)*(P.a.y-P.b.y) );
      float m = ( (P.a.x-P.b.x)*(P.a.x-getX())+(P.a.y-P.b.y)*(P.a.y-getY()) ) / ll;
      float dist = ( (P.a.x - P.b.x) * (P.a.y - getY())-(P.a.y - P.b.y) * (P.a.x - getX()) ) / ( sqrt(ll));
      dist = abs(dist);
      
      if ((dist < r ) && (m < 1) && (m > 0) ) {
        r=dist;
        index=i;
      }
    }
    println("findPair r= " + r);
    if (index > -1)
    {
      Pair pair = (Pair)pairs.get(index);
      Point point = (Point)points.get(100);
      splitPair(pair, point);
    }
    return index;
  }

  private void autoSelect()
  {
    Point P = findPoint(offsetX + (w/2-x) * z, offsetY + (h/2-y) * z, 100.0 * z );
    if ( P == null )
    {
      selected = null;
    }
    else
    {
      selected = P;
    }
  }

  public void moveX(float x)
  {
    offsetX -= x*z;
    clip();
    autoSelect();
  }

  public void moveY(float y)
  {
    offsetY -= y*z;
    clip();
    autoSelect();
  }

  public void startMove()
  {
    movement_enabled = true;
  }

  public void mouseDragged()
  {
    if ( mouseButton == LEFT )
    {
      if ( (selected != null) && ( movement_enabled == true) )
      {
        selected.x -= (pmouseX - mouseX) * z;
        selected.y -= (pmouseY - mouseY) * z;
      }
      else
      {
        offsetX += (pmouseX - mouseX) * z;
        offsetY += (pmouseY - mouseY) * z;
        clip();
      }
    }
  }

  public void mouseReleased()
  {
    movement_enabled = false;
    // println ("mouseReleased");
  }

  // Zoom relativ zur Mitte ( für Tastatur )
  public void zoomin2()
  {
    z/=1.5;
    offsetX += ((w/2-x) * z * 0.5);
    offsetY += ((h/2-y) * z * 0.5);
    clip();
    autoSelect();
  }

  public void zoomout2()
  {
    // println ("zoom out");
    if (z < 2)
    {
      offsetX -= ((w/2-x) * z * 0.5);
      offsetY -= ((h/2-y) * z * 0.5);
      z*=1.5;
      clip();
    }
  }

  // Zoom relativ zu Maus
  public void zoomin()
  {
    // println ("zoom in");
    z/=1.1;
    offsetX += ((mouseX-x) * z * 0.1);
    offsetY += ((mouseY-y) * z * 0.1);
    clip();
  }

  public void zoomout()
  {
    // println ("zoom out");
    if (z < 2)
    {
      offsetX -= ((mouseX-x) * z * 0.1);
      offsetY -= ((mouseY-y) * z * 0.1);
      z*=1.1;
      clip();
    }
  }

  private void clip()
  {
    if (offsetX < 0 ) offsetX = 0;
    if (offsetY < 0 ) offsetY = 0;
    if (offsetX > (image.width - w*z) ) offsetX = (image.width - w*z);
    if (offsetY > (image.height - h*z) ) offsetY = (image.height - h*z);
    Width = (w*z);
    Height = (h*z);
    redraw();
  }

  public float getX() {
    return (offsetX + (mouseX-x) * z);
  }

  public float getY() {
    return (offsetY + (mouseY-y) * z);
  }

  private void readPoints()
  { 
    try {
      BufferedReader reader = createReader("points.txt");
      String line = null;
      Label label = (Label)labels.get(0);
      Integer lcount = 0;
      while ((line = reader.readLine()) != null)
      {
        String[] column = split(line,TAB);
        Point P = new Point();
        P.id    = int(column[0]);
        P.x     = float(column[1]);
        P.y     = float(column[2]);
        P.count = 0;
        if(column.length > 3)
        {
          P.mark  = (short)int(column[3]);
        }
        else
        {
          P.mark=0;
        }
        P.labels  = new ArrayList();
        P.lcount  = new ArrayList();
        P.labels.add(label);
        P.lcount.add(lcount);
        points.add(P);
      } 
    } catch (IOException ioe) 
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + points.size() + " points read ...");
  }

  private void renumberPoints()
  {
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      P.id = (short)i;
    }
  }

  private void writePoints()
  {
    renumberPoints();
    println("writing points.txt");
    PrintWriter writer = createWriter("data/points.txt");
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      writer.println(P.id + "\t" + P.x + "\t" + P.y + "\t" + P.mark);
    }
    writer.flush();
    writer.close();
  }

  private Point findPoint(int id)
  {
    int n = points.size();
    int index = -1;
    Point P = null;
    Label L = null;
    // FIXME: This only works if Point table does not have any gaps
    P = (Point)points.get(id);
    if (P.id == id) return P;
    // FIXME: Otherwise loop through table to find point
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      if (P.id == id)
      {
        println("point " + id + " = points.get()" + i + ");");
        return P;
      }
    }
    println("Panic - point " + id + " not found !!!");
    return null;
  }

  private Pair findOrAddPair(Point a, Point b)
  {
    if (a.id > b.id)
    {
      Point tmp = a;
      a = b;
      b = tmp;
    }
    int n = pairs.size();
    int index = -1;
    Pair P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Pair)pairs.get(i);
      if ((P.a == a) && (P.b == b)) return P;
    }
    P = new Pair();
    P.a = a;
    P.b = b;
    P.length = sqrt( (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y) );
    pairs.add(P);
    return P;
  }

  private void readPolls()
  { 
    try {
      BufferedReader reader = createReader("polls.txt");
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        // ID Geschlecht Alter Ausbildung Einkommen Personen Kinder Taetigkeit Nationalitaet1,2 Nat_Eltern1,2,3,4
        String[] column = split(line,TAB);
        Poll P = new Poll();
        P.id     = (short)int(column[0]);
        P.gender = (byte) int(column[1]);
        P.age    = (byte) int(column[2]);
        P.education = (byte) int(column[3]);

//         int einkommen = 0;
//         switch ((byte) int(column[4])) // Einkommen
//         {
//           case  1: einkommen =  350; break;
//           case  2: einkommen =  850; break;
//           case  3: einkommen = 1250; break;
//           case  4: einkommen = 1750; break;
//           case  5: einkommen = 2250; break;
//           case  6: einkommen = 2750; break;
//           case  7: einkommen = 3250; break;
//           case  8: einkommen = 3750; break;
//           case  9: einkommen = 4250; break;
//           case 10: einkommen = 4750; break;
//         }

        int personen = (byte) int(column[5]);
        int kinder   = (byte) int(column[6]);
        
        
        // Nat: 8 - 13
        P.migration = 0;
        for(int i = 8; i < 14 ; i++)
        {
          int m = 0;
          Boolean a,b;
          a = int(column[i]) != 0 ;
          b = int(column[i]) != 100 ;
          if( a && b  )
          {
            m = 2;
            for(int j = 0; j < EU_List.length; j++)
            {
              if(int(column[i]) == EU_List[j])
              {
                m = 1;
              }
            }
          }
          P.migration = max(P.migration,m);
        }
        // println ("ID: " + P.id + " Migration: " + P.migration);

        // P.income = einkommen / ( 0.5 + personen * 0.5 - kinder * 0.2 ) / 926;
        // println ("ID: " + P.id + " Einkommen-ID: " + column[4] + " Personen:" + personen + " Kinder:" + kinder + " -> " + P.income);
        
        // Ignoriere obige Berechnung und verwende Spalte mit vorberechneten Werten
        P.income = (byte) int(column[14]);
        
        polls.add(P);
      } 
    } catch (IOException ioe) 
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + polls.size() + " polls read ...");
  }

  private Poll findPoll(int id)
  {
    int n = polls.size();
    int index = -1;
    Poll P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Poll)polls.get(i);
      if (P.id == id) return P;
    }
    return null;
  }

  private void readLabels()
  {
    // Column 0 : id
    // Column 1 : poll
    try {
      BufferedReader reader = createReader("labels.txt");
      int id;
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        String[] column = split(line,TAB);
        Label L = new Label();
        L.id  = (short) int(column[0]);
        L.text = column[1];
        labels.add(L);
      } 
    } catch (IOException ioe) 
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + labels.size() + " labels read ...");
  }

  private void renumberLabels()
  {
    int n = labels.size();
    Label L = null;
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      if (L.count == 0)
      {
        labels.remove(i);
        --i;
        --n;
      }
      else
      {
        L.id = (short)i;
      }
    }
  }

  private void writeLabels()
  {
    renumberLabels();
    println("writing labels.txt");
    PrintWriter writer = createWriter("data/labels.txt");
    int n = labels.size();
    Label L = null;
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      writer.println(L.id + "\t" + L.text);
    }
    writer.flush();
    writer.close();
  }
  
  private Label findLabel(int id)
  {
    int n = labels.size();
    int index = -1;
    Label L = null;
    // FIXME: This only works if Point table does not have any gaps
    if (id < n)
    {
      L = (Label)labels.get(id);
      if (L.id == id) return L;
    }
    // FIXME: Otherwise loop through table to find point
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      if (L.id == id) return L;
    }
    return null;
  }

  private void addLabelToPoint(Label label, Point point)
  {
    int n = point.labels.size();
    Integer count = 1;
    for(int i = 0; i < n ; i++)
    {
      Label L = (Label)point.labels.get(i);
      if (L.id == label.id)
      {
        count = (Integer)point.lcount.get(i);
        count++;
        point.lcount.set(i,count);
        return;
      }
    }
    point.labels.add(label);
    point.lcount.add(count);
  }

  private void statisticsReset()
  {
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      for (int j = 0; j < P.gender.length; j++)
      {
        P.gender[j] = 0;
      }
      for (int j = 0; j < P.migration.length; j++)
      {
        P.migration[j] = 0;
      }
      for (int j = 0; j < P.income.length; j++)
      {
        P.income[j] = 0;
      }
      for (int j = 0; j < P.education.length; j++)
      {
        P.education[j] = 0;
      }
      for (int j = 0; j < P.age.length; j++)
      {
        P.age[j] = 0;
      }
    }
  }

  private void statisticsOnPoint(Poll poll, Point point, Label label)
  {
    if (label.id > 0)
    {
      point.gender[poll.gender]++;
      point.migration[poll.migration]++;

      int age = 0;
      if (poll.age < 20)
      {
        age = 0;
      } 
      else if (poll.age < 40)
      {
        age = 1;
      }
      else if (poll.age < 60)
      {
        age = 2;
      } 
      else
      {
        age = 3;
      }
      point.age[age]++;

      point.income[poll.income]++;

      int education = 0;
      if ( poll.education == 1 )
      {
        education = 1;
      }
      else if ( (poll.education >= 2) && (poll.education <= 4) )
      {
        education = 2;
      }
      else if ( (poll.education >= 5) && (poll.education <= 7) )
      {
        education = 3;
      }
      point.education[education]++;
    }
  }

  private void readPath()
  {
    // Column 0 : id
    // Column 1 : poll
    // Column 2 : path
    // Column 3 : label
    // Column 4 : point
    int count = 0;
    try {
      BufferedReader reader = createReader("path.txt");
      Poll poll = findPoll(1);
      Point point = null;
      Label label = null;
      Point lastpoint = null;
      Pair  pair = null;
      String line = null;
      while ((line = reader.readLine()) != null)
      {
        String[] column = split(line,TAB);
        if (poll.id != int(column[1]))
        {
          poll = findPoll(int(column[1]));
        }
        lastpoint = point;

        // Punkt einfügen
        point = findPoint(int(column[4]));
        //++point.count;
        poll.path[int(column[2])].points.add(point);

        // Label Poll einfügen
        label = findLabel(int(column[3]));
        //++label.count;
        poll.path[int(column[2])].labels.add(label);

        // Punkt - Label verknüpfung
        addLabelToPoint(label,point);

        // Statistik an Punkt
        statisticsOnPoint(poll,point,label);

        // Pair einfügen
        if (int(column[0]) > 0)
        {
          pair = findOrAddPair(point,lastpoint);
          poll.path[int(column[2])].pairs.add(pair);
          //++pair.count;
        }
        ++count;
      }
    } catch (IOException ioe)
    {
      System.out.println( "IO error: " + ioe );
    }
    println("* " + count + " pairs read ...");
    println("* " + pairs.size() + " unique pairs found ...");
  }

  private void calcPointColor()
  {
    int n = points.size();
    Point P = null;
    for(int i = 0; i < n ; i++)
    {
      P = (Point)points.get(i);
      float a,b = 0;

      a = P.gender[1] + P.gender[2] + 0.0001;
      a /= 2;
      b += pow(P.gender[1] * P.gender[2] / (a*a),4.0/2.0);

      a = P.age[0] + P.age[1] + P.age[2] + P.age[3] + 0.0001;
      a /= 4;
      b += pow(P.age[0] * P.age[1] * P.age[2] * P.age[3] / (a*a*a*a) ,4.0/4.0);

      a = P.income[1] + P.income[2] + P.income[3] + P.income[4] + 0.0001;
      a /= 4;
      b += pow(P.income[1] * P.income[2] * P.income[3] * P.income[4] / (a*a*a*a) ,4.0/4.0);

      a = P.education[1] + P.education[2] + P.education[3] + 0.0001;
      a /= 3;
      b += pow(P.education[1] * P.education[2] * P.education[3] / (a*a*a) ,4.0/3.0);

      a = P.migration[0] + P.migration[1] + P.migration[2] + 0.0001;
      a /= 3;
      b += pow(P.migration[0] * P.migration[1] * P.migration[2] / (a*a*a) ,4.0/3.0);

      P.heter = 10.0 + b * 18.0;
    }
  }

  private void writePath()
  {
    println("writing path.txt");
    PrintWriter writer = createWriter("data/path.txt");
    int n = polls.size();
    Poll poll = null;
    Point point = null;
    Label label = null;
    for(int i = 0; i < n ; i++)
    {
      poll = (Poll)polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          point = (Point)poll.path[j].points.get(k);
          label = (Label)poll.path[j].labels.get(k);
          // Fortlaufende Nummer im Pfad | Poll-ID | Path-ID ()
          writer.println(k + "\t" + poll.id + "\t" + j + "\t" + label.id + "\t" + point.id);
        }
      }
    }
    writer.flush();
    writer.close();
  }

  private void filter(int gender, int minage, int maxage, int minmigration, int maxmigration, int mineducation, int maxeducation, float minincome, float maxincome)
  {
    int n;
    // Zähler auf Null setzten
    // Punkte
    n = points.size();
    for(int i=0; i < n ; ++i)
    {
      Point point = (Point) points.get(i);
      point.count = 0;
    }
    // Statistik neu berechnen - Reset
    statisticsReset();

    // Wegelemente
    n = pairs.size();
    for(int i = 0; i < n ; ++i)
    {
      Pair pair = (Pair)pairs.get(i);
      pair.count = 0;
    }

    // Polls durchgehen und durchzählen
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);

      // Filterbedingung:
      if ( ( (poll.gender == gender) || (gender == 0) ) && (poll.age > minage ) && (poll.age <= maxage) && ( poll.migration >= minmigration) && (poll.migration <= maxmigration) && ( poll.education >= mineducation) && ( poll.education <= maxeducation ) && (poll.income > minincome ) && ( poll.income <= maxincome) )
      {
        // println(poll.gender + " - " + poll.age + " - " + poll.migration + " - " + poll.education + " - " + poll.income );
        poll.speed = 1.2 - 0.01 * poll.age;
        for(int j=0; j < 2 ; ++j)
        {
          int m;
          // Punkte
          m = poll.path[j].points.size();
          for(int k=0; k < m ; ++k)
          {
            Point point = (Point) poll.path[j].points.get(k);
            Label label = (Label) poll.path[j].labels.get(k);
            if (label.id > 0)
            {
              ++point.count;
            }
            // Statistik neu berechnen
            statisticsOnPoint(poll, point, label);
          }
          // Wegelemente
          m = poll.path[j].pairs.size();
          for(int k=0; k < m ; ++k)
          {
            Pair pair = (Pair) poll.path[j].pairs.get(k);
            ++pair.count;
          }
        }
      }
      else // Filterbedingung
      {
        poll.speed = 0.0;
      }
    }
  }

  public void mergePoints()
  // Set Viewer into Merge-Points-Mode
  {
    if (selected != null)
    {
      if (mode == 2)
      {
        if ((temp != null) && (temp != selected))
        {
          replacePoint(selected,temp);
        }
        selected = null;
        temp = null;
        mode = 0;
      }
      else
      {
        temp = selected;
        selected = null;
        mode = 2;
      }
    }
    else
    {
      temp = null;
      mode = 0;
    }
  }

  public void replacePoint(Point a, Point b)
  // Replace every Point a with Point b in all Polls and Pairs
  // Point a should be unused afterwards and could be deleted.
  {
    int n;
    // Loop all Polls
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          Point point = (Point) poll.path[j].points.get(k);
          if (point == a)
          {
            poll.path[j].points.set(k,b);
            println("Poll " + poll.id + " : replacing Point " + a.id + " with " + b.id);
            // Punkt - Label verknüpfung für Punkt b einfügen
            Label label = (Label) poll.path[j].labels.get(k);
            addLabelToPoint(label,b);
          }
        }
      }
    }
    // Loop all Pairs
    n = pairs.size();
    for(int i = 0; i < n ; ++i)
    {
      Pair pair = (Pair)pairs.get(i);
      if (pair.a == a)
      {
        pair.a = b;
        println("Pair " + i + " : replacing Point " + a.id + " with " + b.id);
      }
      if (pair.b == a)
      {
        pair.b = b;
        println("Pair " + i + " : replacing Point " + a.id + " with " + b.id);
      }
    }
    // Finally remove point a
    n = points.indexOf(a);
    points.remove(n);
  }

  public Label findOrAddLabel(String text)
  {
    int n;
    // Search for existing Label
    n = labels.size();
    Label L = null;
    for(int i = 0; i < n ; i++)
    {
      L = (Label)labels.get(i);
      if (L.text == text) return L;
    }
    // Not found -> Add new
    L = new Label();
    L.id  = (short) n;
    L.text = text;
    labels.add(L);
    return L;
  }

  public void renamePoint(String text)
  {
    if (selected != null)
    {
      renamePoint(selected, text);
    }
  }

  private void renamePoint(Point point, String text)
  {
    Label label = (Label)labels.get(0);
    Integer lcount = 0;
    int n;
    n = point.labels.indexOf(label);
    if (n > -1)
    {
      lcount = (Integer)point.lcount.get(n);
    }
    point.labels.clear();
    point.lcount.clear();
    point.labels.add(label);
    point.lcount.add(lcount);

    label = findOrAddLabel(text);

    // Loop all Polls
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          Point P = (Point) poll.path[j].points.get(k);
          if (P == point)
          {
            Label L = (Label) poll.path[j].labels.get(k);
            if ((L.id != 0) && (L.id != label.id))
            {
              --L.count;
              ++label.count;
              poll.path[j].labels.set(k,label);
              addLabelToPoint(label,point);
              println("Poll " + poll.id + " : replacing Label " + L.id + " with " + label.id);
            }
          }
        }
      }
    }

  }

  private void splitPoint()
  {
    Point point = selected;
    // Point P = null;
    int n;
    int firstNewPointID = points.size();

    // Create new Points
    n = point.labels.size();
    for(int i = 0; i < n ; ++i)
    {
      Point P = new Point();
      P.id    = points.size();
      P.x     = point.x + 3*i;
      P.y     = point.y;
      P.labels  = new ArrayList();
      P.lcount  = new ArrayList();
      Label L = (Label)point.labels.get(i);
      P.labels.add(L);
      Integer lcount = (Integer)point.lcount.get(i);
      P.lcount.add(lcount);
      P.count = (short)int(lcount);
      points.add(P);
    }

    // Loop all Polls
    n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].points.size();
        for(int k=0; k < m ; ++k)
        {
          Point P = (Point) poll.path[j].points.get(k);
          if (P == point)
          {
            Label L = (Label) poll.path[j].labels.get(k);
            int id = firstNewPointID + point.labels.indexOf(L);
            poll.path[j].points.set(k,(Point)points.get(id));
            // Update Pairs
            if (k > 0)
            {
              Pair pair = findOrAddPair((Point)poll.path[j].points.get(k-1),(Point)poll.path[j].points.get(k));
              poll.path[j].pairs.set(k-1,pair);
            }
            if (k < m-1)
            {
              Pair pair = findOrAddPair((Point)poll.path[j].points.get(k),(Point)poll.path[j].points.get(k+1));
              poll.path[j].pairs.set(k,pair);
            }
          }
        }
      }
    }
    
    // Delete old Point from List
    n = points.indexOf(selected);
    points.remove(n);

    selected = null;
  }
  
  // Split Path a insterting b
  public void splitPair(Pair a, Point b)
  {
    Pair a1 = findOrAddPair(a.a,b);
    Pair a2 = findOrAddPair(a.b,b);
    a1.count += a.count;
    a2.count += a.count;
    Label label = (Label)labels.get(0);
    int n = polls.size();
    for(int i = 0; i < n ; ++i)
    {
      Poll poll = (Poll) polls.get(i);
      for(int j=0; j < 2 ; ++j)
      {
        int m = poll.path[j].pairs.size();
        for(int k=0; k < m ; ++k)
        {
          Pair pair = (Pair) poll.path[j].pairs.get(k);
          if (pair == a)
          {
            poll.path[j].points.add(k,b);
            poll.path[j].labels.add(k,label);
            println("Poll " + poll.id + " : inserting Point " + b.id + " at " + k);
            poll.path[j].pairs.set(k,a1);
            poll.path[j].pairs.add(k,a2);
          }
        }
      }
    }
    n = pairs.size();
    for(int i = 0; i < n ; ++i)
    {
      Pair pair = (Pair) pairs.get(i);
      if (pair == a)
      {
        println("Pair " + i + " : inserting Point " + b.id);
        pairs.set(i,a1);
        pairs.add(i,a2);
      }
    }
  }

  public void markPoint(int mark)
  {
    if (selected != null)
    {
      selected.mark = (short) mark;
    }
  }
  
} // End Class Viewer



